using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;

namespace ClientProxy
{
    public class SOSParser
    {
        /*
         * Krav til SIP SOS (fra http://tools.ietf.org/html/draft-ietf-sipping-sos-02)
         * 1.It is RECOMMENDED that SIP-based [RFC3261] end systems and proxy
         * servers support a uniform emergency call identifier, namely the SIP
         * and SIPS URIs with the reserved user name "sos" within any domain,
         * e.g.,
         *
         * sip:sos@example.com
         * sips:sos@example.com
         *
         * 2. The reserved name is case-insensitive
         * 3. The host part of the emergency URI SHOULD be the host portion of the address-of-record of the caller.
         * 4. The SIP URI user name "sos" MUST NOT be assigned to any regular user.

         * */
        public SOSParser()
        {
            //Empty constructor
        }


        public bool isSOS(byte[] buffer)
        {
            ArrayList needles = getNeedles();
            String text = ASCIIEncoding.ASCII.GetString(buffer, 0, buffer.Length);

            foreach (string needle in needles)
            {
                // toUpper makes it case insensitive
                if (text.ToUpper().IndexOf(needle.ToUpper()) != -1)
                {
                    return true;
                }
            }
            return false;
        }
        private ArrayList getNeedles()
        {
            // disse kan evt. hentes fra tekstfil, eller en annen klasse
            ArrayList needles = new ArrayList();
            //Skeord, bare legg til flere her
            needles.Add("sos@");
            needles.Add("sos.");

            return needles;
        }
    }
}
