using System;
using System.Xml;
using System.Collections.Generic;
//using System.ComponentModel;
//using System.Data;
//using System.Drawing;
//using System.Text;
//using System.Windows.Forms;
//using System.IO;
//using System.Reflection;

namespace GeoPos
{
    public class XMLparser
    {
        //private double utm_x;
        //private double utm_y;

        public XMLparser()
        {}

        public string parse(string type, string response, string responsetype)
        {
            XmlDocument xmlDoc = new XmlDocument();

            try
            {                
                xmlDoc.LoadXml(response);
            }
            catch (Exception ex)
            {
                return ex.Message;
            }

            if(type == "MAC")
            {
                return parseMAC(xmlDoc, responsetype);
            }
            else if(type == "IP")
            {
                return parseIP(xmlDoc, responsetype);
            }
            else
            {
                return "-1"; //Error, feil type
            }
        }

        /**
         * @param MAC XML response
         * @return Parsed MAC XML response
         */     
        private string parseMAC(XmlDocument xmlDoc, string responsetype)
        {
            try
            {
                //Next use the load method to load the XML document from the specified stream.
                //Get root
                XmlNode root = xmlDoc.DocumentElement.SelectSingleNode("/GposResponse/ResponseBody/XYPosition");

                XmlNode x = root.SelectSingleNode("X");
                XmlNode y = root.SelectSingleNode("Y");
                XmlNode longitude = root.SelectSingleNode("Longitude");
                XmlNode latitude = root.SelectSingleNode("Latitude");
                XmlNode floorId = root.SelectSingleNode("FloorId");
                XmlNode civicLocation = root.SelectSingleNode("Elem");

                XmlNode civicAddress = civicLocation.NextSibling;
                XmlNode geospatialLocation = civicAddress.NextSibling;
                XmlNode position = geospatialLocation.NextSibling;

                //Output
                string output = "";

                if (responsetype.Equals(String.Concat("COORDINATES")))
                {
                    output += String.Concat(longitude.InnerXml, " " , latitude.InnerXml);
                }
                else
                {
                    output = "x-coordinate\t: " + x.InnerXml + "\r\n";
                    output += "y-coordinate\t: " + y.InnerXml + "\r\n";
                    output += "Longitude\t\t: " + longitude.InnerXml + "\r\n";                    
                    output += "Latitude\t\t: " + latitude.InnerXml + "\r\n";
                    output += "FloorId\t\t: " + floorId.InnerXml + "\r\n";
                    output += "Civic location\t: " + civicLocation.InnerXml + "\r\n";
                    output += "Civic address\t: " + civicAddress.InnerXml + "\r\n";
                    output += "Geospatial loc\t: " + geospatialLocation.InnerXml + "\r\n";
                    output += "Position\t\t: " + position.InnerXml + "\r\n";
                }
                //utm_y = Convert.ToDouble(latitude.InnerXml);
                //utm_x = Convert.ToDouble(longitude.InnerXml);
                return output;
            }
            catch (Exception ex)
            {
                XmlNode error = xmlDoc.DocumentElement.SelectSingleNode("/GposResponse/ResponseBody/ErrorList/Error/ErrorResid");
               
                if ( Convert.ToInt16(error.InnerText) > 0 )
                {
                    return "NOLOCATION";
                }
                else
                {
                    return ex.Message;
                }    
            }
        }

        /**
         * @param IP XML response
         * @return Parsed IP XML response
         */         
        private string parseIP(XmlDocument xmlDoc, string responsetype)
        { return null;}

        /*
        private double[] getUTM()
        {
            double[] res = new double[2];
            res[0] = utm_x;
            res[1] = utm_y;
            return res;
        }
        */
    }    
}