﻿using System;
using System.Collections.Generic;
using System.Text;
using OpenNETCF;
using OpenNETCF.Net;

namespace MAC
{
    class UserSystem
    {
        private static string napMacAddress = "Error";
        private static string localMacAddress = "";
        private static string ipAddress = "";
        private static string status = "0";

        public UserSystem()
        {
        }
        public string getAddress(string address_type)
        {
            if( address_type.Equals("NMAC") )
            {
                return getNapMac();
            }
            if( address_type.Equals("LMAC") )
            {
                return getLocalMac();
            }
            if (address_type.Equals("IP"))
            {
                return getMyIP();
            }
            return "Error : Could not recognize address type";
        }
        public string getStatus()
        {
            return status;
        }

        private string getNapMac()
        {
            int i = 0;//DEBUG

            foreach (OpenNETCF.Net.Adapter FocusedAdapter in OpenNETCF.Net.Networking.GetAdapters())
            {
                OpenNETCF.Net.AccessPointCollection AccessPoints = FocusedAdapter.NearbyAccessPoints;

                foreach (OpenNETCF.Net.AccessPoint FocusedAccessPoint in AccessPoints)
                {
                    i++;//DEBUG
                    napMacAddress = BitConverter.ToString(FocusedAccessPoint.MacAddress).Replace("-", ":").Substring(0, 17);
                    //int SignalStrength = FocusedAccessPoint.SignalStrength.Decibels
                }
            }
            status = Convert.ToString(i);//DEBUG

            return napMacAddress;
        }

        private string getLocalMac()
        {
            AdapterCollection adaptersCollection = Networking.GetAdapters();
            try
            {
                localMacAddress = BitConverter.ToString(adaptersCollection[0].MacAddress).Replace("-", ":").Substring(0, 17);
            }
            catch (ArgumentOutOfRangeException)
            {
                localMacAddress = "Error";
            }

            return localMacAddress;
        }

        private string getMyIP()
        {
            AdapterCollection adaptersCollection = Networking.GetAdapters();
            try
            {
                ipAddress = adaptersCollection[0].CurrentIpAddress;
            }
            catch (ArgumentOutOfRangeException)
            {
                ipAddress = "Error";
            }

            return ipAddress;
        }
    }
}
