﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using GeoPos;
using GPS;
using MAC;

namespace MyLocation
{
    public partial class LocationServices : Form
    {
        private GPS.GpsPosition pos;
        private NetworkInformation ni;

        public LocationServices()
        {
            InitializeComponent();
            ni = new NetworkInformation();
        }

        public UserData UserData
        {
            get
            {
                throw new System.NotImplementedException();
            }
            set
            {
            }
        }

        private void b_back_Click(object sender, EventArgs e)
        {
            tb_main.Text = "";
            tb_input.Text = "";
            label_top.Text = "";
        }

        private void b_geopos_Click(object sender, EventArgs e)
        {
                if (tb_input.Text.Length > 1)
                {
                    //MAC adresse i tekstfeltet
                    tb_main.Text = "Venter på GeoPos..";

                    UserData ud = new UserData();
                    DateTime before = DateTime.Now;
                    GeoPos.GeoPos gp = new GeoPos.GeoPos();
                    DateTime after = DateTime.Now;
                    TimeSpan time = after.Subtract(before);
                    tb_main.Text = gp.getLocationFor(ud.getUsername(), ud.getPassword(), "MAC", tb_input.Text.ToLower(), "ALL");
                    tb_main.Text = "\r\nTime :\t" + time.ToString();
                    label_top.Text = "GeoPos posisjonsdata:";
                    tb_input.Visible = false;
                }
                else
                {
                    //Ingen mac address i tekstfeltet
                    label_top.Text = "MAC :";
                    tb_main.Text = "Skriv inn gyldig MAC adresse";
                    tb_input.Text = "00:02:6f:43:91:a8";
                    tb_input.Focus();
                }    
            
        }

        private void b_mac_Click(object sender, EventArgs e)
        {
            tb_main.Text = "Søker etter MAC adresser..";           

            MAC.MAC mac = new MAC.MAC();
            tb_main.Text = mac.getAddress();
            label_top.Text = "MAC og IP adresser:";
        }

        private void b_gps_Click(object sender, EventArgs e)
        {
            tb_main.Text = "Søker etter GPS..";
            DateTime before = DateTime.Now;

            GPS.GPS gps = new GPS.GPS();                  
           
            gps.Open();
            gps.LocationChanged += new LocationChangedEventHandler(gps_LocationChanged);
            gps.DeviceStateChanged += new DeviceStateChangedEventHandler(gps_DeviceStateChanged);

            GPS.GpsPosition gps_pos = gps.GetPosition();

            DateTime after = DateTime.Now;
            TimeSpan time = after.Subtract(before);

            tb_main.Text =  "Latitude\t: " + gps_pos.Latitude.ToString() + "\r\nLongitude\t: " + gps_pos.Longitude.ToString();
            tb_main.Text += "\r\nTime \t:" + time.ToString();
            label_top.Text = "GPS posisjonsdata: (oppdateres ved ";

        }
        private void gps_LocationChanged(object sender, LocationChangedEventArgs args)
        {
            pos = args.Position;
            //latitude = pos.LongitudeRaw;
            //longitude = pos.LatitudeRaw;
        }
        private void gps_DeviceStateChanged(object sender, DeviceStateChangedEventArgs args)
        {
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            tb_main.Text = "";
            tb_input.Text = "";
            label_top.Text = "";
        }

        private void menuItem2_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void b_networkinformation_Click(object sender, EventArgs e)
        {
            tb_main.Text = ni.getNetworkInformation();
        }
    }
}
