﻿using System;
using System.Collections.Generic;
using System.Text;
using OpenNETCF;
using OpenNETCF.Net;

namespace MyLocation
{
    class NetworkInformation
    {
        string ssid = "";
        string numberOfAPs = "";
        string signalStrength = "";
        string napMacAddress = "";
        int noAPsWithSameSSID;

        public NetworkInformation() {}

        public string getNetworkInformation()
        {
            foreach (OpenNETCF.Net.Adapter FocusedAdapter in OpenNETCF.Net.Networking.GetAdapters())
            {
                ssid = FocusedAdapter.AssociatedAccessPoint;
                
                OpenNETCF.Net.AccessPointCollection AccessPoints = FocusedAdapter.NearbyAccessPoints;
                
                AccessPoint ap = AccessPoints.FindBySSID(ssid);
                //napMacAddress = BitConverter.ToString(ap.MacAddress).Replace("-", ":").Substring(0, 17); ;
                numberOfAPs = AccessPoints.Count.ToString();
                signalStrength = ap.SignalStrengthInDecibels.ToString();

                noAPsWithSameSSID = 0;
                foreach (AccessPoint accp in AccessPoints)
                {
                    if (accp.Name == ssid)
                    {
                        noAPsWithSameSSID++;
                    }
                }

          }
          return String.Concat("SSID\t", ssid, "\r\nStrength\t", signalStrength, "\r\nNoAP\t", numberOfAPs, "\r\nNoAPinSSID\t", noAPsWithSameSSID.ToString()); 
          
        }
    }
}
