﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SIPparser
{
    public class SIPparser
    {
        private AddressRegister ar;

        public SIPparser(string remotehost, string remoteport, string localport)
        {
            ar = new AddressRegister(remotehost, remoteport, localport);
        }

        internal AddressRegister AddressRegister
        {
            get
            {
                throw new System.NotImplementedException();
            }
            set
            {
            }
        }

        // Changes client entries in the SIP message
        public void changeOutgoing(ref byte[] buffer)
        {
            //LAST KNOWN CONFIG: string address_register = "callme.item.ntnu.no:5060";
            string address_register = ar.getRemoteHost() + ":" + ar.getRemotePort();

            //LAST KNOWN CONFIG: string address_via = "129.241.209.203";
            string address_via = ar.getIP();

            //LAST KNOWN CONFIG: string address_contact = "129.241.209.203:5060";
            string address_contact = ar.getIP() + ":" + ar.getLocalPort();
            //string address_contact = ar.getRemoteHost() + ":" + ar.getLocalPortIn();

            //LAST KNOWN CONFIG: string address_from = "callme.item.ntnu.no:5060";
            string address_from = ar.getRemoteHost() + ":" + ar.getRemotePort();

            //LAST KNOWN CONFIG: string address_to = "callme.item.ntnu.no:5060";
            string address_to = ar.getRemoteHost() + ":" + ar.getRemotePort();

            //LAST KNOWN CONFIG: string address_call = "129.241.209.203";
            string address_call = ar.getIP();

            string address_invite = ar.getRemoteHost() + ":" + ar.getRemotePort();

            string address_ack = ar.getRemoteHost() + ":" + ar.getRemotePort();

            string address_bye;

            bool flag_register = false;
            bool flag_invite = false;
            bool flag_status = false;
            bool flag_bye = false;
            bool flag_ack = false;

            try
            {
                string string_to_parse = ASCIIEncoding.ASCII.GetString(buffer, 0, buffer.Length);
                string output_parsed = "";
                int str_len = string_to_parse.Length;

                //Del opp i linjer
                char split = Convert.ToChar("\n");
                string[] stringA = string_to_parse.Split(split);

                bool firstround = true;
                foreach (string line in stringA)
                {
                    //Trenger bare gjøre dette første runde
                    if (firstround)
                    {
                        //Sjekk hvilken type melding det er
                        if (line.ToUpper().StartsWith("INVITE"))
                        {
                            flag_invite = true;
                        }
                        else if (line.ToUpper().StartsWith("ACK"))
                        {
                            flag_ack = true;
                        }
                        else if (line.ToUpper().StartsWith("BYE"))
                        {
                            flag_bye = true;
                        }
                        else if (line.ToUpper().StartsWith("SIP"))
                        {
                            flag_status = true;
                        }
                        else if (line.ToUpper().StartsWith("REGISTER"))
                        {
                            flag_register = true;
                        }
                        firstround = false;
                    }
                    if (flag_invite)
                    {
                        if (line.ToUpper().StartsWith("INVITE"))
                        {
                            address_invite = ar.getRemoteHost() + ":" + ar.getRemotePort();
                            output_parsed += changeInvite(line, address_invite);
                        }
                        else if (line.ToUpper().StartsWith("CONTACT"))
                        {
                            //address_contact = ar.getRemoteHost() + ":" + ar.getRemotePort();

                            address_contact = ar.getIP() + ":" + ar.getLocalPort();
                            output_parsed += changeContact(line, address_contact);
                        }
                        else if (line.ToUpper().StartsWith("FROM"))
                        {
                            output_parsed += changeFrom(line, address_from);
                        }
                        else if (line.ToUpper().StartsWith("TO"))
                        {
                            output_parsed += changeTo(line, address_to);
                        }
                        else if (line.ToUpper().StartsWith("VIA"))
                        {
                            //output_parsed += "Via: SIP/2.0/UDP 129.241.200.44;rport=7000;\r\n";
                            //output_parsed += changeVia(line, address_via);
                            //output_parsed += "Via: SIP/2.0/UDP " + ar.getIP() + ";rport=" + ar.getLocalPortIn() + "\r\n";
                            if (line.IndexOf("rport;") != -1)
                            {
                                output_parsed += line.Replace("rport;", String.Concat("rport=", ar.getLocalPort(), ";")) + "\n";
                            }
                            else if (line.IndexOf(ar.getRemotePort()) != -1)
                            {
                                output_parsed += line.Replace(ar.getRemotePort(), ar.getLocalPort()) + "\n";
                            }
                            else
                            {
                                output_parsed += line + "\n";
                            }
                        }
                        else if (line.ToUpper().StartsWith("CALL"))
                        {
                            output_parsed += changeCall(line, address_call);
                            //output_parsed += line + "\n";
                        }
                        else
                        {
                            output_parsed += line + "\n";
                        }
                    }
                    else if (flag_status)
                    {
                        if (line.ToUpper().StartsWith("VIA"))
                        {
                            output_parsed += line + "\n";
                        }
                        else
                        {
                            output_parsed += line + "\n";
                        }
                    }
                    else if (flag_register)
                    {
                        if (line.ToUpper().StartsWith("REGISTER"))
                        {
                            output_parsed += changeRegister(line, address_register);
                            //output_parsed += line + "\n";
                        }
                        else if (line.ToUpper().StartsWith("CONTACT"))
                        {
                            address_contact = ar.getIP() + ":" + ar.getLocalPort();
                            output_parsed += changeContact(line, address_contact);
                        }
                        else if (line.ToUpper().StartsWith("VIA"))
                        {
                            //output_parsed += "Via: SIP/2.0/UDP " + ar.getIP() + ";rport=" + ar.getLocalPortIn() + "\r\n";
                            //output_parsed += line + "\n";
                            //output_parsed += changeVia(line, address_via);
                            if (line.IndexOf("rport;") != -1)
                            {
                                output_parsed += line.Replace("rport;", String.Concat("rport=", ar.getLocalPort(), ";")) + "\n";
                            }
                            else if (line.IndexOf(String.Concat(":", ar.getRemotePort())) != -1)
                            {
                                output_parsed += line.Replace(String.Concat(":", ar.getRemotePort()), String.Concat(":", ar.getLocalPort())) + "\n";
                            }
                            else
                            {
                                output_parsed += line + "\n";
                            }
                        }
                        else
                        {
                            output_parsed += line + "\n";
                        }
                    }
                    else if (flag_ack)
                    {
                        if (line.ToUpper().StartsWith("ACK"))
                        {
                            address_ack = String.Concat(ar.getCalleIp(), ":", ar.getRemotePort());
                            output_parsed += changeAck(line, address_ack);
                        }
                        else if (line.ToUpper().StartsWith("VIA"))
                        {
                            output_parsed += String.Concat("Via: SIP/2.0/UDP ", ar.getIP(), ";rport=", ar.getLocalPort(), "\r\n");
                        }
                        else if (line.ToUpper().StartsWith("ROUTE"))
                        {
                            //Do nothing
                        }
                        else
                        {
                            output_parsed += line + "\n";
                        }
                    }
                    else if (flag_bye)
                    {
                        if (line.ToUpper().StartsWith("BYE"))
                        {
                            address_bye = String.Concat(ar.getCalleIp(), ":", ar.getRemotePort());
                            output_parsed += changeBye(line, address_bye);
                        }
                        /*
                        else if (line.ToUpper().StartsWith("FROM"))
                        {
                            //address_from = ar.getRemoteHost() + ":" + ar.getRemotePort();
                            output_parsed += changeFrom(line, address_from);
                        }
                        */
                        else if (line.ToUpper().StartsWith("VIA"))
                        {
                            //output_parsed += String.Concat("Via: SIP/2.0/UDP ", ar.getLocalHost(), ";rport=", ar.getLocalPort(), "\r\n"); 
                            output_parsed += line.Replace(ar.getLocalHost(), ar.getIP()).Replace("rport;", String.Concat("rport=", ar.getLocalPort(), ";")) + "\n";
                        }
                        else
                        {
                            output_parsed += line + "\n";
                        }
                    }
                    else
                    {
                        if (line.StartsWith(" "))
                        {
                        }
                        else
                        {
                            output_parsed += line + "\n";
                        }
                    }
                }
                //output_parsed += "\0";
                //char trim = Convert.ToChar("\r\n");
                buffer = ASCIIEncoding.ASCII.GetBytes(output_parsed);
            }
            catch
            {
                throw;
            }
        }

        // Changes host entries in the SIP message
        public void changeIncoming(ref byte[] buffer)
        {
            string address_via = ar.getLocalHost();
            string address_call = ar.getIP();
            string address_from = ar.getLocalHost() + ":" + ar.getLocalPort();
            string address_to = ar.getLocalHost() + ":" + ar.getLocalPort();
            string address_contact = ar.getLocalHost() + ":" + ar.getRemotePort();
            string address_bye = ar.getIP() + ":" + ar.getRemotePort();
            string address_invite = ar.getLocalHost() + ":" + ar.getLocalPort();

            bool flag_invite = false;
            bool flag_status = false;
            bool flag_status_ringing = false;
            bool flag_status_trying = false;
            bool flag_status_ok = false;
            bool flag_bye = false;
            bool flag_ack = false;
            bool ok_via_added = false;
            bool invite_via_added = false;

            try
            {
                string string_to_parse = ASCIIEncoding.ASCII.GetString(buffer, 0, buffer.Length);
                string output_parsed = "";
                int str_len = string_to_parse.Length;

                //Del opp i linjer
                char split = Convert.ToChar("\n");
                string[] stringA = string_to_parse.Split(split);

                bool firstround = true;
                foreach (string line in stringA)
                {
                    //Trenger bare gjøre dette første runde
                    if (firstround)
                    {
                        //Sjekk hvilken type melding det er
                        if (line.ToUpper().StartsWith("INVITE"))
                        {
                            flag_invite = true;
                        }
                        else if (line.ToUpper().StartsWith("ACK"))
                        {
                            flag_ack = true;
                        }
                        else if (line.ToUpper().StartsWith("BYE"))
                        {
                            flag_bye = true;
                        }
                        else if (line.ToUpper().StartsWith("SIP"))
                        {
                            if (line.ToUpper().IndexOf("TRYING") != -1)
                            {
                                flag_status_trying = true;
                            }
                            else if (line.ToUpper().IndexOf("RINGING") != -1)
                            {
                                flag_status_ringing = true;
                            }
                            else if (line.ToUpper().IndexOf("OK") != -1)
                            {
                                flag_status_ok = true;
                            }
                            else
                            {
                                flag_status = true;
                            }
                        }
                        firstround = false;
                    }

                    /* INVITE melding */
                    if (flag_invite)
                    {
                        if (line.ToUpper().StartsWith("INVITE"))
                        {
                            address_invite = ar.getLocalHost() + ":" + ar.getLocalPort();
                            output_parsed += changeInvite(line, address_invite);
                            //output_parsed += "Record-Route: <sip:127.0.0.1:7000;lr=on>\r\n";

                            output_parsed += "Via: SIP/2.0/UDP 127.0.0.1;rport=7000\r\n";
                        }
                        else if (line.ToUpper().StartsWith("VIA"))
                        {
                            /*
                            //output_parsed += String.Concat("Via: SIP/2.0/UDP ", ar.getLocalHost(), ";rport=", ar.getLocalPortOut(),"\r\n");
                            if (line.Contains("rport=5060"))
                            {
                                output_parsed += line.Replace("rport=5060", "rport=7000") + "\n";
                            }
                            else
                            {
                            }
                            output_parsed += line + "\n"; 
                             * 
                             * */
                        }
                        else if (line.ToUpper().StartsWith("CONTACT"))
                        {
                            address_contact = ar.getLocalHost() + ":" + ar.getLocalPort();
                            output_parsed += changeContact(line, address_contact);
                        }
                        /*
                        else if (line.ToUpper().StartsWith("TO"))
                        {
                            address_to = ar.getLocalHost() + ":" + ar.getLocalPort();
                            output_parsed += changeContact(line, address_to);
                        }
                        else if (line.ToUpper().StartsWith("FROM"))
                        {
                            address_from = ar.getLocalHost() + ":" + ar.getLocalPort();
                            output_parsed += changeContact(line, address_from);
                        }
                        */
                        else
                        {
                            output_parsed += line + "\n";
                        }
                    }
                    /* ACK melding */
                    else if (flag_ack)
                    {
                        if (line.ToUpper().StartsWith("VIA"))
                        {
                            //output_parsed += "Via: SIP/2.0/UDP " + ar.getIP() + ";rport=" + ar.getLocalPortOut() + "\r\n";
                            output_parsed += line + "\n";
                        }
                        else
                        {
                            output_parsed += line + "\n";
                        }
                    }
                    /* BYE melding */
                    else if (flag_bye)
                    {
                        if (line.ToUpper().StartsWith("VIA"))
                        {
                            //output_parsed += "Via: SIP/2.0/UDP " + ar.getIP() + ";rport=" + ar.getLocalPortOut() + "\r\n";
                            output_parsed += line + "\n";
                            //output_parsed += changeVia(line, address_via);
                        }
                        else
                        {
                            output_parsed += line + "\n";
                        }
                    }
                    /* STATUS melding */
                    else if (flag_status)
                    {
                        output_parsed += line + "\n";
                    }
                    else if (flag_status_ok)
                    {
                        address_contact = ar.getLocalHost() + ":" + ar.getLocalPort();

                        if (line.ToUpper().StartsWith("CONTACT"))
                        {
                            output_parsed += changeContact(line, address_contact);
                        }
                        else
                        {

                            if (line.ToUpper().StartsWith("VIA"))
                            {
                                output_parsed += line.Replace(String.Concat("rport=", ar.getLocalPort(), ";"), String.Concat("rport=", ar.getLocalPort(), ";")) + "\n";
                                //output_parsed += line + "\n";
                            }
                            else
                            {
                                output_parsed += line + "\n";
                            }
                        }
                    }
                    else if (flag_status_ringing)
                    {
                        if (line.ToUpper().StartsWith("VIA"))
                        {
                            //output_parsed += "Via: SIP/2.0/UDP " + ar.getIP() + ";rport=" + ar.getLocalPortOut() + "\r\n";
                            ok_via_added = true;
                            output_parsed += line + "\n";
                        }
                        else
                        {
                            output_parsed += line + "\n";
                        }
                    }
                    else if (flag_status_trying)
                    {
                        if (line.ToUpper().StartsWith("VIA"))
                        {
                            //output_parsed += "Via: SIP/2.0/UDP " + ar.getIP() + ";rport=" + ar.getLocalPortOut() + "\r\n";
                            ok_via_added = true;
                            output_parsed += line + "\n";
                        }
                        else
                        {
                            output_parsed += line + "\n";
                        }
                    }
                    //Annen linje
                    else
                    {
                        if (line.StartsWith(" "))
                        {
                        }
                        else
                        {
                            output_parsed += line + "\n";
                        }
                    }
                }
                //output_parsed += "\0";
                buffer = ASCIIEncoding.ASCII.GetBytes(output_parsed);
            }
            catch
            {
                throw;
            }
        }

        private string changeInvite(string line, string address_invite)
        {
            int r_start = line.ToUpper().IndexOf("@") + 1;
            int r_end = line.LastIndexOf(" ");
            int r_length = r_end - r_start;
            if (r_length > 0)
            {
                string r = line.Substring(r_start, r_length);
                return line.Replace(r, address_invite) + "\n";
            }
            else
            {
                return "";
            }
        }

        private string changeContact(string line, string address_contact)
        {
            int r_start = line.IndexOf("@") + 1;
            int r_end = line.IndexOf(">");
            int r_length = r_end - r_start;
            if (r_length > 0)
            {
                string r = line.Substring(r_start, r_length);
                return line.Replace(r, address_contact) + "\n";
            }
            else
            {
                return "";
            }
        }

        private string changeFrom(string line, string address_from)
        {
            int r_start = line.IndexOf("@") + 1;
            int r_end = line.IndexOf(">");
            int r_length = r_end - r_start;
            if (r_length > 0)
            {
                string r = line.Substring(r_start, r_length);
                return line.Replace(r, address_from) + "\n";
            }
            else
            {
                return "";
            }
        }

        private string changeTo(string line, string address_to)
        {
            int r_start = line.IndexOf("@") + 1;
            int r_end = line.IndexOf(">");
            int r_length = r_end - r_start;
            if (r_length > 0)
            {
                string r = line.Substring(r_start, r_length);
                return line.Replace(r, address_to) + "\n";
            }
            else
            {
                return "";
            }
        }

        private string changeVia(string line, string address_via)
        {
            int r_start = line.LastIndexOf(" ") + 1;
            int r_end = line.IndexOf(";");
            int r_length = r_end - r_start;
            if (r_length > 0)
            {
                string r = line.Substring(r_start, r_length);
                return line.Replace(r, address_via) + "\n";
            }
            else
            {
                return "";
            }
        }

        private string changeBye(string line, string address_bye)
        {
            int r_start = line.ToUpper().IndexOf("@") + 1;
            int r_end = line.LastIndexOf(" ");
            int r_length = r_end - r_start;
            if (r_length > 0)
            {
                string r = line.Substring(r_start, r_length);
                return line.Replace(r, address_bye) + "\n";
            }
            else
            {
                return "";
            }
        }

        private string changeCall(string line, string address_call)
        {
            int r_start = line.ToUpper().IndexOf("@") + 1;
            int r_start_length = line.Substring(0, r_start).Length;
            int r_length = line.Length - r_start_length - 1;
            if (r_length > 0)
            {
                string r = line.Substring(r_start, r_length);
                return line.Replace(r, address_call) + "\n";
            }
            else
            {
                return "";
            }
        }

        private string changeRegister(string line, string address_register)
        {
            int r_start = line.ToUpper().IndexOf("SIP:") + 4;
            int r_end = line.LastIndexOf(" ");
            int r_length = r_end - r_start;
            if (r_length > 0)
            {
                string r = line.Substring(r_start, r_length);
                return line.Replace(r, address_register) + "\n";
            }
            else
            {
                return "";
            }
        }
        private string changeAck(string line, string address_ack)
        {
            int r_start = line.ToUpper().IndexOf("@") + 1;
            int r_end = line.LastIndexOf(" ");
            int r_length = r_end - r_start;
            if (r_length > 0)
            {
                string r = line.Substring(r_start, r_length);
                return line.Replace(r, address_ack) + "\n";
            }
            else
            {
                return "";
            }
        }
    }
}
